<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolPodlaKategorieVozidla;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use InvalidArgumentException;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaKategorieVozidla;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\DataTableRowContract;

/**
 * Class PocetKontrolPodlaKategorieVozidlaDataTableRow
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\DataTables\Pracovisko\PocetKontrolPodlaKategorieVozidla
 */
final class PocetKontrolPodlaKategorieVozidlaDataTableRow implements DataTableRowContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var string
     */
    private string $kategoriaVozidla;

    /**
     * @var int
     */
    private int $spolu = 0;

    /**
     * @param string $kategoriaVozidla
     */
    public function __construct(string $kategoriaVozidla)
    {
        $this->kategoriaVozidla = $kategoriaVozidla;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaKategorieVozidla $pocetKontrolPodlaKategorieVozidla
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaKategorieVozidla $pocetKontrolPodlaKategorieVozidla): self
    {
        if (0 !== substr_compare($this->kategoriaVozidla, $pocetKontrolPodlaKategorieVozidla->kategoria(), 0, null, true)) {
            throw new InvalidArgumentException(sprintf(
                'Ocakava sa kategoria vozidla %s, vstupny atribut obsahuje kategoriu vozidla %s',
                $this->kategoriaVozidla,
                $pocetKontrolPodlaKategorieVozidla->kategoria()
            ));
        }

        $this->spolu += $pocetKontrolPodlaKategorieVozidla->pocet();

        return $this;
    }

    /**
     * @return string
     */
    public function kategoria(): string
    {
        return $this->kategoriaVozidla;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'label' => ucfirst($this->kategoriaVozidla),
            'data' => [
                'spolu' => $this->spolu,
            ],
        ];
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
